Download it now!
Bug 91385 - Conditional formats based on volatile functions are not updated when document is recalculated with F9/shift-F9
Summary: Conditional formats based on volatile functions are not updated when document...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
4.4.2.2 release
Hardware: Other All
: medium minor
Assignee: Markus Mohrhard
URL:
Whiteboard: target:6.2.0
Keywords:
Depends on:
Blocks: Conditional-Formatting
  Show dependency treegraph
 
Reported: 2015-05-19 12:28 UTC by lvm
Modified: 2018-07-14 08:28 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments
testcase (8.66 KB, application/vnd.oasis.opendocument.spreadsheet)
2015-05-19 12:28 UTC, lvm
Details

Note You need to log in before you can comment on or make changes to this bug.
Description lvm 2015-05-19 12:28:45 UTC
Created attachment 115707 [details]
testcase

I've got a spreadsheet containing dates with conditional formats based on how late or early these dates are, conditions like 'cell value is greater than now()'. Unfortunately there is no way to force the update of conditional formatting: F9 and shift-F9 have no effect, only after a cell of the spreadsheet - any cell, even the one not involved in conditional formatting, is actually modified formats finally change. I find it quite awkward and would like calc to update conditional formats based on volatile functions when F9 is pressed the same way the data based on volatile functions is updated.

I am attaching a simple testcase wich doesn't require waiting for a certain time. Orange background is applied to cell A1 if its value (0.5) is greater than rand(). Start modifying other cells randomly - orange background starts changing on and off. Now start pressing F9 or shift-F9: nothing happens.
Comment 1 m.a.riosv 2015-05-19 20:05:21 UTC
Hi @lvm, thanks for reporting.

I think Conditional Format does their own calculations and needs the:
 Menu/Tools/Cells content/Autocalculate activated.

Your sample file has it activated and works fine for me, any place I modify a cell and A1 background color it's update.

Win7x64
Version: 4.4.3.2 Build ID: 88805f81e9fe61362df02b9941de8e38a9b5fd16
Comment 2 lvm 2015-05-20 06:02:17 UTC
I am afraid you missed my point: in this testcase background color should change when F9 and/or shift-F9 is pressed alone, with no modification to any of the cells. Definitely when Shift-F9 is pressed. And yes, I do have tools.cell content.autocalculate checked.
Comment 3 raal 2015-05-22 11:28:04 UTC
F9 works (cond format is changing) with LO 4.4.3, win7
Comment 4 lvm 2015-05-22 11:55:53 UTC
Still not working for me with 4.4.3.2 windows 7. Not even in D5 :)
Comment 5 raal 2015-05-22 11:59:25 UTC
version is oldest
Comment 6 Buovjaga 2015-05-23 12:45:37 UTC
Inputting random things to cells works, but F9 doesn't.

Win 7 Pro 64-bit Version: 5.1.0.0.alpha1+
Build ID: d8208da8576874fdb07014287e6cbc0aeba741bb
TinderBox: Win-x86@39, Branch:master, Time: 2015-05-23_09:23:03
Locale: fi-FI (fi_FI)
Comment 7 Buovjaga 2015-05-23 12:51:05 UTC
Now I noticed, that F9 does work, but I have to switch focus to some other window! So the painting update seems broken.
Comment 8 Markus Mohrhard 2016-04-10 21:23:15 UTC
That should ideally be fixed now with the listener based conditional format code.
Comment 9 Buovjaga 2016-04-12 11:33:04 UTC
(In reply to Markus Mohrhard from comment #8)
> That should ideally be fixed now with the listener based conditional format
> code.

No, I still see the problem I mentioned in comment 7.

Win 7 Pro 64-bit Version: 5.2.0.0.alpha0+
Build ID: b0e678c86136ef6d65cea66168a99217664c0278
CPU Threads: 4; OS Version: Windows 6.1; UI Render: default; 
TinderBox: Win-x86@42, Branch:master, Time: 2016-04-11_23:06:28
Locale: fi-FI (fi_FI)
Comment 10 QA Administrators 2017-05-22 13:23:21 UTC Comment hidden (obsolete)
Comment 11 lvm 2017-05-23 08:56:13 UTC
still reproducible in 5.3.3.2 for win-32
Comment 12 Markus Mohrhard 2018-07-13 22:44:19 UTC
Should not be too difficult to fix.
Comment 13 Commit Notification 2018-07-14 08:28:39 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=1ce2d70bc29b348f2f819d616a897e1dcb6a1a9f

tdf#91385, recalc cond format formulas during hard recalc

It will be available in 6.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 14 Commit Notification 2018-07-14 08:28:46 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=be7203eca9745bd39d167777d7ec824954b3e4c0

add test for tdf#91385

It will be available in 6.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.